﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr150_1
{
    // Базовый класс: 
    class Alpha
    {
        // Открытое поле: 
        public char alpha;
        // Виртуальный метод: 
        public virtual void show()
        {
            Console.WriteLine("Класс Alpha: {0}", alpha);
        }
        // Конструктор с одним аргументом: 
        public Alpha(char a)
        {
            alpha = a;
        }
        // Конструктор создания копии:
        public Alpha(Alpha obj)
        {
            alpha = obj.alpha;
        }
    }

    // Производный класс от класса Alpha: 
    class Bravo : Alpha
    {
        // Открытое поле: 
        public string bravo;
        // Переопределение виртуального метода: 
        public override void show()
        {
            Console.WriteLine("Класс Bravo: {0} и {1}", alpha, bravo);
        }
        // Конструктор с двумя аргументами:
        public Bravo(char a, String b)
            : base(a)
        {
            bravo = b;
        }
        // Конструктор создания копии:
        public Bravo(Bravo obj)
            : base(obj)
        {
            bravo = obj.bravo;
        }
    }

    // Производный класс от класса Bravo: 
    class Charlie : Bravo
    {
        // Открытое поле: 
        public int charlie;
        // Переопределение виртуального метода: 
        public override void show()
        {
            Console.WriteLine("Класс Charlie: {0}, {1} и {2}", alpha, bravo, charlie);
        }
        // Конструктор с тремя аргументами: 
        public Charlie(char a, string b, int c)
            : base(a, b)
        {
            charlie = c;
        }
        // Конструктор создания копии:
        public Charlie(Charlie obj)
            : base(obj)
        {
            charlie = obj.charlie;
        }
    }

    // Класс с главным методом:
    class Program
    {
        static void Main()
        {
            // Главный метод:
            // Создание объекта класса Alpha:
            Alpha objA = new Alpha('A');
            Alpha objA_copy = objA;
            // Проверка значения поля: 
            objA.show();
            Console.WriteLine("Работает конструктор копирования:");
            objA_copy.show();
            Console.WriteLine();
            // Создание объекта класса Bravo:
            Bravo objB = new Bravo('A', "BCDE");
            // Объектной переменной базового класса присваивается 
            // ссылка на объект производного класса: 
            objA = objB;
            // Проверка значений полей: 
            objA.show();
            objB.show();
            Bravo objB_copy = objB;
            Console.WriteLine("Работает конструктор копирования:");
            objB_copy.show();
            Console.WriteLine();
            // Создание объекта класса Charlie:
            Charlie objC = new Charlie('F', "GHIJ", 10);
            // Объектной переменной базового класса присваивается 
            // ссылка на объект производного класса: 
            objA = objC;
            objB = objC;
            // Проверка значений полей: 
            objA.show();
            objB.show();
            objC.show();
            Charlie objC_copy = objC;
            Console.WriteLine("Работает конструктор копирования:");
            objC_copy.show();
            // Задержка:
            Console.ReadLine();
        }
    }
}
